


include windows.inc
include user32.inc
Include kernel32.inc
include gdi32.inc
include masm32.inc
include comctl32.inc

includeLib user32.lib
includeLib kernel32.lib
includeLib gdi32.lib
includelib masm32.lib
includelib comctl32.lib


	$String MACRO sTEXT
		LOCAL szText
		.data
		 szText db sTEXT, 0
		.code
		EXITM <Offset szText>
	ENDM
	
	
	$Const MACRO Num
		result textequ @CatStr(<c_>,<%Num>)
	% IFNDEF result
		  .const 
		    result dd Num
		  .code
	  ENDIF
		EXITM <result>
	ENDM
	
	$fConst MACRO Num
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL4__>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(<_>,@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL4_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF formatted
		  .const 
		    formatted REAL4 Num
		  .code
	 	ENDIF
		EXITM <formatted>
	ENDM
	
	$float MACRO num
		OPVAL TEXTEQU %OPATTR (num)        ; "Op type"
		DECPT TEXTEQU %@InStr(1, num, <.>) ; "Decimal Point"
		
		IF     OPVAL AND 00010000y		; Register
			exitm <num>
		ELSEIF OPVAL AND 00000100y		; Immediate
			DUMMYSTR textequ @CatStr(num,<.0>)
			exitm $fConst(%DUMMYSTR)
		ELSEIF OPVAL AND 00000010y		; Memory reference
			exitm <num>
		ELSEIF DECPT NE 0				; Float
			exitm <$fConst(num)>
		ELSE							; Unknown
			.err <This is unknown: num -- OPATTR = OPVAL -- Not float>
		ENDIF
	ENDM
	
	
	$dConst MACRO Num
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL8__>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL8_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF formatted
		  .const 
		    formatted REAL8 Num
		  .code
	 	ENDIF
		EXITM <formatted>
	ENDM
	
	$double MACRO num
		OPVAL TEXTEQU %OPATTR (num)        ; "Op type"
		DECPT TEXTEQU %@InStr(1, num, <.>) ; "Decimal Point"
		
		IF     OPVAL AND 00010000y		; Register
			exitm <num>
		ELSEIF OPVAL AND 00000100y		; Immediate
			DUMMYSTR textequ @CatStr(num,<.0>)
			exitm $dConst(%DUMMYSTR)
		ELSEIF OPVAL AND 00000010y		; Memory reference
			exitm <num>
		ELSEIF DECPT NE 0				; Float
			exitm <$dConst(num)>
		ELSE							; Unknown
			.err <This is unknown: num -- OPATTR = OPVAL -- Not float>
		ENDIF
	ENDM
	
	
.DATA
ClassName		db "MainWinClass",0
KeyTrackerClassName db "KeyTrackerClass",0
szAppName		db "Hooker3 Application",0
MenuName		db "FirstMenu",0
szFileNew		db "You selected 'New'.",0
szFileOpen		db "You selected 'Open'.",0
szHelpAbout		db "You selected 'About'.",0

ErrorCountString 		db	"Number of errors: "
ErrorCountStringNumber  db 50 dup(0)
ErrorLineString 		db	"Error: Line "
ErrorLineStringNumber  db 50 dup(0)

.DATA?
hInstance		HINSTANCE ?
CommandLine		LPSTR ?
hHeap			HANDLE ?
hMenu			HMENU ?
hwnd			HWND ?
myKeyTrackerWindow HWND ?
hBtnSend		HWND ?
hMainEdit		HWND ?
hLabel1			HWND ?
hLabel2			HWND ?
hTimer			HWND ?
hStatusBar		HWND ?
FlagSave		DWORD ?

thatPos POINT <?>
myDevMode DEVMODE <>


IDT_TIMER1		EQU 5
IDT_TIMER_MOUSETRACK EQU 50

IDC_STATUS equ 3007

IDM_FILE_NEW		EQU 1
IDM_FILE_OPEN		EQU 2
IDM_HELP_ABOUT		EQU 3
IDM_FILE_EXIT		EQU 4
IDC_EDIT_X		EQU 1003
IDC_EDIT_Y		EQU 1006
IDC_EDIT_COLOR		EQU 1008
IDC_EDIT_INVERT		EQU 1010
DLG_Help		EQU 2001
DLG_MouseTracker		EQU 2002

IDM_MOUSE_TRACKER		EQU 6

IDM_MACRO_ERRORCHECK		EQU 9
IDM_KEY_TRACKER		EQU 11
IDC_PAUSEBUTTON		EQU 2011
IDC_STATIC_COLOR		EQU 2012
IDC_STATIC_INVERT		EQU 2013
hookerIcon		EQU 3055
myAccelerators		EQU 4000
accel_ErrorCheck		EQU 9



;=================================================================
;  SENDINPUT .... WHY IS IT SO COMPLEX?
;  YOU MICROSOFT PEOPLE THINK THIS IS FUNNY?
;=================================================================

KEYEVENTF_EXTENDEDKEY                equ 1
KEYEVENTF_KEYUP                      equ 2
KEYEVENTF_UNICODE 				     equ 4
KEYEVENTF_SCANCODE 					 equ 8 
comment ^
MOUSEEVENTF_MOVE                     equ 1h
MOUSEEVENTF_LEFTDOWN                 equ 2h
MOUSEEVENTF_LEFTUP                   equ 4h
MOUSEEVENTF_RIGHTDOWN                equ 8h
MOUSEEVENTF_RIGHTUP                  equ 10h
MOUSEEVENTF_MIDDLEDOWN               equ 20h
MOUSEEVENTF_MIDDLEUP                 equ 40h
MOUSEEVENTF_WHEEL       			  equ 800h
MOUSEEVENTF_ABSOLUTE                 equ 8000h
^


S_key_INPUT STRUCT
	  sType   DWORD ?
	wVk		WORD ?
	wScan	WORD ?
	dwFlags DWORD ?
	time	DWORD ?
	dwExtraInfo DWORD ?
	    	    DWORD ?
	            DWORD ?
S_key_INPUT ENDS
S_mouse_INPUT STRUCT
	  sType   DWORD ?
	dwX		  DWORD ?
	dwY		  DWORD ?
	mouseData DWORD ?
	dwFlags	  DWORD ?
	dwTime	  DWORD ?
	dwExtraInfo DWORD ?
S_mouse_INPUT ENDS

.DATA
MYKEYBINPUT   S_key_INPUT    <INPUT_KEYBOARD, 0,0,0,0,0,0>
MYMOUSEINPUT  S_mouse_INPUT  <INPUT_MOUSE,    0,0,0,0,0,0>

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@






	
	ITEM STRUCT 
		pRight dd ?
		pLeft dd ?
		pName dd ?
		dwNameLength dd ?
		pData dd ?
		dwDataLength dd ?
	ITEM ENDS
	
	Emm db 'm',0
	EmptyString db 0
	
	ROOTITEM			ITEM <0,0,Offset Emm,1,Offset EmptyString,0>
	
	myTextRect RECT <70,110,110,135>
	TreeSize 	 dd 0
	TreeSizeA	 DWORD 030303030h